'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// 1. find to `exports.default`
// 2. find to all Expression(`exports.default`, `exports.foo` etc)
// 3. add `module.exports` if exists only `exports.default` assignment
// The above works after executing `preset-env`(transform-es2015-modules-*) in `Plugin.post`

module.exports = function (_ref) {
  var template = _ref.template,
      types = _ref.types;

  var pluginOptions = void 0;
  var ExportsDefaultVisitor = {
    AssignmentExpression: function AssignmentExpression(path) {
      var name = path.get('left.object.name').node + '.' + path.get('left.property.name').node;
      if (name === 'exports.default') {
        var finder = new ExportsFinder(path);
        if (!finder.isOnlyExportsDefault()) {
          return;
        }
        if (finder.isAmd()) {
          return;
        }
        var rootPath = finder.getRootPath();

        // HACK: `path.node.body.push` instead of path.pushContainer(due doesn't work in Plugin.post)
        rootPath.node.body.push(template('module.exports = exports.default')());
        if (pluginOptions.addDefaultProperty) {
          rootPath.node.body.push(template('module.exports.default = exports.default')());
        }
      }
    }
  };

  return {
    visitor: {
      Program: function Program(path, state) {
        // HACK: can't get plugin options in Plugin.post
        pluginOptions = state.opts;
      }
    },
    post: function post(fileMap) {
      fileMap.path.traverse(ExportsDefaultVisitor);
    }
  };
};

var ExportsFinder = function () {
  function ExportsFinder(exportsDefaultPath) {
    _classCallCheck(this, ExportsFinder);

    this.path = exportsDefaultPath;
    this.hasExportsDefault = false;
    this.hasExportsNamed = false;
    this.hasModuleExports = false;
  }

  _createClass(ExportsFinder, [{
    key: 'getRootPath',
    value: function getRootPath() {
      return this.path.parentPath.parentPath;
    }
  }, {
    key: 'isOnlyExportsDefault',
    value: function isOnlyExportsDefault() {
      var _this = this;

      this.getRootPath().get('body').forEach(function (path) {
        if (path.isVariableDeclaration()) {
          _this.findExport(path.get('declarations.0'), 'init');
        } else {
          if (path.isExpressionStatement() && path.get('expression').isAssignmentExpression()) {
            _this.findExport(path);
          }
        }
      });
      return this.hasExportsDefault && !this.hasExportsNamed && !this.hasModuleExports;
    }
  }, {
    key: 'findExport',
    value: function findExport(path) {
      var property = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'expression';

      // Not `exports.anything`, skip
      if (!path.get(property + '.left').node || !path.get(property + '.left.object').node) {
        return;
      }

      var objectName = path.get(property + '.left.object.name').node;
      var propertyName = path.get(property + '.left.property.name').node;
      if (objectName === 'exports') {
        if (propertyName === 'default') {
          this.hasExportsDefault = true;
        } else {
          this.hasExportsNamed = true;
        }
      }
      if (objectName + '.' + propertyName === 'module.exports') {
        this.hasModuleExports = true;
      }
      return null;
    }
  }, {
    key: 'isAmd',
    value: function isAmd() {
      var rootPath = this.getRootPath();
      var hasntAmdRoot = !(rootPath.parentPath && rootPath.parentPath.parentPath);
      if (hasntAmdRoot) {
        return false;
      }

      var amdRoot = rootPath.parentPath.parentPath;
      if (!amdRoot.isCallExpression()) {
        return false;
      }
      if (amdRoot.get('callee.name').node === 'define') {
        return true;
      }
      return false;
    }
  }]);

  return ExportsFinder;
}();
//# sourceMappingURL=index.js.map